//******************************************************************
// Exponentiation program
//******************************************************************
#include <iostream>

using namespace std;

int Power( int, int );

int main()
{
    int number;              // Number that is being raised to power
    int exponent;            // Power the number is being raised to

    cin >> number >> exponent;
    cout << Power(number, exponent);            // Nonrecursive call
    return 0;
}

//******************************************************************

int Power( /* in */ int x,   // Number that is being raised to power
           /* in */ int n )  // Power the number is being raised to

// Computes x to the n power by multiplying x times the result of
// computing x to the n - 1 power.

// Precondition:
//     x is assigned  &&  n > 0
// Postcondition:
//     Function value == x raised to the power n
// Note:
//     Large exponents may result in integer overflow

{
    if (n == 1)
        return x;                                  // Base case
    else
        return x * Power(x, n - 1);                // Recursive call
}
